FLTK: Fl_PNG_Image Class Reference

FLTK

Public Member Functions | List of all members
Fl_PNG_Image Class Reference

The Fl_PNG_Image class supports loading, caching, and drawing of Portable Network Graphics (PNG) image files. More...

`#include <Fl_PNG_Image.H>`

Inheritance diagram for Fl_PNG_Image:

## Public Member Functions
| Fl_PNG_Image (const char *filename)
| The constructor loads the named PNG image from the given png filename. More...
| Fl_PNG_Image (const char *name_png, const unsigned char *buffer, int datasize)
| Constructor that reads a PNG image from memory. More...
Public Member Functions inherited from Fl_RGB_Image
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the FLTK color value c. More...
Fl_Image * | copy ()
virtual Fl_Image * | copy (int W, int H)
| The copy() method creates a copy of the specified image. More...
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale. More...
void | draw (int X, int Y)
virtual void | draw (int X, int Y, int W, int H, int cx=0, int cy=0)
| Draws the image with a bounding box. More...
| Fl_RGB_Image (const Fl_Pixmap *pxm, Fl_Color bg=FL_GRAY)
| The constructor creates a new RGBA image from the specified Fl_Pixmap. More...
| Fl_RGB_Image (const uchar *bits, int W, int H, int D=3, int LD=0)
| The constructor creates a new image from the specified data. More...
virtual void | label (Fl_Menu_Item *m)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
virtual void | label (Fl_Widget *w)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
virtual void | uncache ()
| If the image has been cached for display, delete the cache data. More...
virtual | ~Fl_RGB_Image ()
| The destructor frees all memory and server resources that are used by the image.
Public Member Functions inherited from Fl_Image
Fl_Image * | copy ()
| The copy() method creates a copy of the specified image. More...
int | count () const
| The count() method returns the number of data values associated with the image. More...
int | d () const
| Returns the current image depth. More...
const char *const * | data () const
| Returns a pointer to the current image data array. More...
void | draw (int X, int Y)
| Draws the image. More...
int | fail ()
| Returns a value that is not 0 if there is currently no image available. More...
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth. More...
int | h () const
| Returns the current image height in pixels.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out. More...
int | ld () const
| Returns the current line data size in bytes. More...
int | w () const
| Returns the current image width in pixels.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Additional Inherited Members
Static Public Member Functions inherited from Fl_RGB_Image
static size_t | max_size ()
| Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object. More...
static void | max_size (size_t size)
| Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object. More...
Static Public Member Functions inherited from Fl_Image
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int). More...
Public Attributes inherited from Fl_RGB_Image
int | alloc_array
| If non-zero, the object's data array is delete[]'d when deleting the object.
const uchar * | array
| Points to the start of the object's data array.
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_NO_IMAGE = -1
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current array pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it. More...
void | h (int H)
| Sets the current image height in pixels.
void | ld (int LD)
| Sets the current line data size in bytes. More...
void | w (int W)
| Sets the current image width in pixels.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_PNG_Image class supports loading, caching, and drawing of Portable Network Graphics (PNG) image files.

The class loads colormapped and full-color images and handles color- and alpha-based transparency.

## Constructor & Destructor Documentation

## ◆ Fl_PNG_Image() [1/2]

Fl_PNG_Image::Fl_PNG_Image | ( | const char * | filename | ) |

The constructor loads the named PNG image from the given png filename.

The destructor frees all memory and server resources that are used by the image.

Use Fl_Image::fail() to check if Fl_PNG_Image failed to load. fail() returns ERR_FILE_ACCESS if the file could not be opened or read, ERR_FORMAT if the PNG format could not be decoded, and ERR_NO_IMAGE if the image could not be loaded for another reason.

Parameters

  [in] | filename | Name of PNG file to read

## ◆ Fl_PNG_Image() [2/2]

Fl_PNG_Image::Fl_PNG_Image | ( | const char * | name_png,
|  | const unsigned char * | buffer,
|  | int | maxsize
| ) |  |

Constructor that reads a PNG image from memory.

Construct an image from a block of memory inside the application. Fluid offers "binary Data" chunks as a great way to add image data into the C++ source code. name_png can be NULL. If a name is given, the image is added to the list of shared images (see: Fl_Shared_Image) and will be available by that name.

Parameters

  name_png | A name given to this image or NULL
  buffer | Pointer to the start of the PNG image in memory
  maxsize | Size in bytes of the memory buffer containing the PNG image

The documentation for this class was generated from the following files:

- Fl_PNG_Image.H
- Fl_PNG_Image.cxx

- © 1998-2016 by Bill Spitzak and others.